#include "Menu.h"

void Menu_RunMainMenu(void)
{
	static struct Option_Class Menu_StartOptionList[] = {
		{"<<<"},
		{"Tools", Menu_RunToolsMenu},	   // 工具
		{"Games", Menu_RunGamesMenu},	   // 游戏
		{"Setting", Menu_RunSettingMenu},  // 设置
		{"Information", Menu_Information}, // 信息
		{".."}};

	Menu_RunMenu(Menu_StartOptionList);
}

void Menu_RunToolsMenu(void)
{
	static struct Option_Class Menu_ToolsOptionList[] = {
		{"<<<"},
		{"歌曲"},					   // 6-1 定时器定时中断
		{"视频"},				   // 6-6 输入捕获模式测频率
		{"小说", Tools_PWM_Output}, // 6-3 PWM驱动LED呼吸灯

		{".."}};

	Menu_RunMenu(Menu_ToolsOptionList);
}

void Menu_RunGamesMenu(void)
{
	static struct Option_Class Menu_GamesOptionList[] = {
		{"<<<"},
		{".."}};

	Menu_RunMenu(Menu_GamesOptionList);
}

void Menu_Information(void)
{
	uint8_t Angle = 233;
	while (1)
	{
		OLED_Clear();

		OLED_ShowImage(88, 8, 32, 32, goutou);
		OLED_Rotation_Block(88 + 16, 8 + 16, 16, Angle * 360 / 256);

		Angle += Menu_RollEvent() * 8;
		Angle += 2;

		OLED_ShowString(2, 0, "Menu V1.8", OLED_8X16);
		OLED_ShowString(2, 32, "By:Adam", OLED_8X16);
		OLED_ShowString(2, 48, "UP:加油哦大灰狼", OLED_8X16);

		OLED_Update();
		if (Menu_EnterEvent())
		{
			return;
		}
		if (Menu_BackEvent())
		{
			return;
		}
	}
}

/**********************************************************/
